# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from .call_params import CallParams

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class BatchObject(pydantic.BaseModel):
    batch_id: str = pydantic.Field()
    """
    The unique identifier for the batch.
    """

    campaign_id: str
    created_at: dt.datetime = pydantic.Field()
    """
    The date and time the batch was created.
    """

    label: str = pydantic.Field()
    """
    The label you assigned to the batch (if any).
    """

    base_prompt: str = pydantic.Field()
    """
    The prompt or task used for all the phone calls in the batch.
    """

    endpoint_code: str = pydantic.Field()
    """
    Enterprise customers with custom endpoints will see the endpoint code here (if specified).
    
    The default value is `API`.
    """

    call_params: CallParams = pydantic.Field()
    """
    The base call parameters used to create the batch.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
