# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...core.datetime_utils import serialize_datetime
from .batch_analysis_object import BatchAnalysisObject
from .status_enum import StatusEnum

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class RetrieveBatchAnalysisResponse(pydantic.BaseModel):
    status: StatusEnum = pydantic.Field()
    """
    Whether the request was successful or not.
    """

    message: str = pydantic.Field()
    """
    An error message or confirmation that the request was successful.
    """

    analysis: typing.List[BatchAnalysisObject] = pydantic.Field()
    """
    An array of analysis objects, each corresponding to a call within the batch.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
